using System;
using System.Windows.Forms;
using System.Drawing;

public class Engine {
    public static GameData data;
    public static GameForm form;
    public static Random rnd;
    static void Main() {
        data = new GameData();
        form = new GameForm();
        rnd = new Random();
        ResetGame();
        Application.Run(form);
    }
    public static void ResetGame() {
        data.Initialize();
        form.UpdateScreen();//ŏ̉ʂ\zB
        if (rnd.Next(2)==0) {
            data.isPlayerBlack = true;
            data.isPlayerTurn = true;
            form.timer.Stop();
            form.PutText("M̎ԂłBM͍łB");
        } else {
            data.isPlayerBlack = false;
            data.isPlayerTurn = false;
            form.timer.Start();
            form.PutText("Rs[^̎ԂłB");
            form.ComputerTurn();
        }
        form.ClickWaitMode = false;
    }

}

public class GameForm : Form {
    public Bitmap Screen;
    public Timer timer;
    public GameData data;
    public int compx, compy;
    public bool ClickWaitMode;
    public GameForm() : base() {
        ClientSize = new Size(640, 480);
        FormBorderStyle = FormBorderStyle.FixedSingle;
        StartPosition = FormStartPosition.CenterScreen;
        Text = "C# Reversi";
        BackColor = Color.FromArgb(0, 0, 0);
        MaximizeBox = false;
        SetStyle(
            ControlStyles.DoubleBuffer |
            ControlStyles.UserPaint |
            ControlStyles.AllPaintingInWmPaint, true
        );
        Screen = new Bitmap(640, 480);
        timer = new Timer();
        timer.Interval = 1000;//Œł1b͍lt
        timer.Tick += MyTimer;
        MouseDown += MyMouseDown;
        data = Engine.data;
    }
    protected override void  OnFormClosing(FormClosingEventArgs e) {
        if (MessageBox.Show("IĂ낵łH", "ImF", MessageBoxButtons.YesNo) == DialogResult.No) {
            e.Cancel = true;   
        }
        base.OnFormClosing(e);
    }
    private void MyMouseDown(object sender, MouseEventArgs e) {
        if (ClickWaitMode) {
            Engine.ResetGame();
            if (data.isPlayerTurn == false) ComputerTurn();
            return;
        }
        if (data.isPlayerTurn == false) return;
        int x = (e.X - 160) / 40;
        int y = (e.Y - 80) / 40;
        if (x < 0 || x > 7 || y < 0 || y > 7) return;
        if (data.CheckStone(x, y, (data.isPlayerBlack == true) ? 1 : 2) == false) return;
        data.PutStone(x, y, (data.isPlayerBlack == true) ? 1 : 2);
        UpdateScreen();
        if (data.CanPutStone((data.isPlayerBlack) ? 2 : 1) == true) {
            data.isPlayerTurn = false;
            timer.Start();
            PutText("Rs[^̎ԂłB");
            ComputerTurn();
        } else {
            if (data.CanPutStone((data.isPlayerBlack) ? 1 : 2) == false) {
                GameSet();
                return;
            }
            PutText("Rs[^̓pXAM̎ԂłBM"+((data.isPlayerBlack==true)?"":"")+"łB");
        }
        return;
    }
    private void MyTimer(object sender, EventArgs e) {
        //^C}Cxg
        if (data.isPlayerTurn == true) {
            //Ȃ͂Ȃ񂾂ǈꉞ
            timer.Stop();
            return;
        } else {
            data.PutStone(compx, compy, (data.isPlayerBlack) ? 2 : 1);
            UpdateScreen();
            if (data.CanPutStone((data.isPlayerBlack) ? 1 : 2) == true) {
                data.isPlayerTurn = true;
                timer.Stop();
                PutText("M̎ԂłBM"+((data.isPlayerBlack==true)?"":"")+"łB");
            } else {
                if (data.CanPutStone((data.isPlayerBlack) ? 2 : 1) == false) {
                    GameSet();
                    return;
                }
                timer.Stop();
                timer.Start();//^C}̃ZbgB
                PutText("Rs[^̎ԂłB");
                ComputerTurn();
            }
            return;
        }
    }
    protected override void OnPaint(PaintEventArgs e) {
        base.OnPaint(e);
        e.Graphics.DrawImage(Screen, 0 , 0);
    }
    public void UpdateScreen () {
        //XN[XVB
        Graphics g=Graphics.FromImage(Screen);
        Pen BlackPen = new Pen(Color.Black);
        Pen WhitePen = new Pen(Color.White);
        Pen BrownPen = new Pen(Color.Brown);
        Brush GreenBrush = new SolidBrush(Color.Green);
        Brush WhiteBrush = new SolidBrush(Color.White);
        Brush BlackBrush = new SolidBrush(Color.Black);
        g.FillRectangle(BlackBrush, 0, 0, 640, 480);
        for (int x = 0; x < 8; x++) {
            for (int y = 0; y < 8; y++)  {
                switch (data.board[x, y]) {
                    case 0://
                        g.FillRectangle(GreenBrush, x * 40 + 160, y * 40 + 80, 40, 40);
                        g.DrawRectangle(BrownPen, x * 40 + 160, y * 40 + 80, 40, 40);
                        break;
                    case 1://
                        g.FillRectangle(GreenBrush, x * 40 + 160, y * 40 + 80, 40, 40);
                        g.DrawRectangle(BrownPen, x * 40 + 160, y * 40 + 80, 40, 40); 
                        g.FillEllipse(BlackBrush, x * 40 + 161, y * 40 + 81, 38, 38);
                        g.DrawEllipse(WhitePen, x * 40 + 161, y * 40 + 81, 38, 38);
                        break;
                    case 2://
                        g.FillRectangle(GreenBrush, x * 40 + 160, y * 40 + 80, 40, 40);
                        g.DrawRectangle(BrownPen, x * 40 + 160, y * 40 + 80, 40, 40);
                        g.FillEllipse(WhiteBrush, x * 40 + 161, y * 40 + 81, 38, 38);
                        g.DrawEllipse(BlackPen, x * 40 + 161, y * 40 + 81, 38, 38); 
                        break;
                }
            }
        }
        Invalidate();
        Update();
    }
    public void GameSet() {
        timer.Stop();
        int black=data.Count(1);
        int white=data.Count(2);
        if (black > white) {
            PutText("܂");
        } else if (black < white) {
            PutText("܂");
        } else {
            PutText("ł");
        }
        ClickWaitMode = true;
    }
    public void ComputerTurn() {
        data.ComputerTurn(out compx, out compy, (data.isPlayerBlack==true)?2:1);
    }
    public void PutText(string text) {
        Graphics g = Graphics.FromImage(Screen);
        Brush brush=new SolidBrush(Color.White);
        g.DrawString(text, this.Font, brush, 10, 10);
        Invalidate();
        Update();
    }
}

public class GameData {
    public bool isPlayerBlack, isPlayerTurn;
    public int[,] board;
    public static int[,,] p;//_\
    int count;
    static GameData() {
        p = new int[8, 8, 2];//_\
        int x, y;
        for (x = 0; x < 8; x++) {
            for (y = 0; y < 8; y++) {
                p[x, y, 0] = -1;
            }
        }
        p[0, 0, 0] = p[7, 7, 0] = p[7, 0, 0] = p[0, 7, 0] = 1000;
        p[1, 1, 0] = p[6, 6, 0] = p[6, 1, 0] = p[1, 6, 0] = -50;
        p[1, 0, 0] = p[0, 1, 0] = p[6, 7, 0] = p[7, 6, 0] =
        p[7, 1, 0] = p[1, 7, 0] = p[6, 0, 0] = p[0, 6, 0] = -30;
        p[3, 3, 0] = p[3, 4, 0] = p[4, 4, 0] = p[4, 3, 0] = 5;
        for (x = 0; x < 8; x++) {
            for (y = 0; y < 8; y++) {
                p[x, y, 1] = 1;
            }
        }
    }
    public GameData() {
        board = new int[8, 8];//0= 1= 2=񋓌^ɂׂH
    }
    public void Initialize () {
        //IZ̏ݒ
        isPlayerBlack = false;//{͂Őݒ肷ӖȂǈꉞB
        isPlayerTurn = false;//{͂Őݒ肷ӖȂǈꉞB
        for (int x = 0; x < 8; x++) {
            for (int y = 0; y < 8; y++) {
                board[x, y] = 0;
            }
        }
        board[3, 4] = board[4, 3] = 1;
        board[3, 3] = board[4, 4] = 2;
        count = 0;
    }
    public bool CanPutStone(int s) {
        for (int y = 0; y < 8; y++) {
            for (int x = 0; x < 8; x++) {
                if (CheckStone(x, y, s) == true) return true;
            }
        }
        return false;
    }
    public int Count(int s) {
        int count=0;
        for (int x = 0; x < 8; x++) {
            for (int y = 0; y < 8; y++) {
                if (board[x, y] == s) count++;
            }
        }
        return count;
    }
    public static bool CheckStoneBoard(int x, int y, int s, int[,] b) {
        if (b[x, y] != 0) return false;//󔒂ȂƒuȂ
        //WɐL΂ĂāA͂ł邩ǂ𒲂ׂ΂B
        int es = (s == 1) ? 2 : 1;//G̐
        for (int vx = -1; vx < 2; vx++) {
            for (int vy = -1; vy < 2; vy++) {
                if (vx == 0 && vy == 0) continue;
                if (x + vx < 0 || x + vx > 7 || y + vy < 0 || y + vy > 7) continue;
                if (b[x + vx, y + vy] != es) continue;
                //̕ɓG̐΂̂ŁAƂ́ẢɎ̐΂΂B
                int x2 = x + vx * 2, y2 = y + vy * 2;
                while (true) {
                    if (x2 < 0 || x2 > 7 || y2 < 0 || y2 > 7) break;//݂͂Ă͂Ȃ
                    if (b[x2, y2] == 0) break;//󔒂Ă͂Ȃ
                    if (b[x2, y2] == s) return true;//ł
                    x2 += vx; y2 += vy;
                }
            }
        }
        return false;
    }
    public bool CheckStone(int x, int y, int s) {
        return CheckStoneBoard(x, y, s, board);
    }
    public static void PutStoneBoard(int x, int y, int s, int[,] b) {
        //CheckStoneBoard̉pB
        b[x, y] = s;
        int es = (s == 1) ? 2 : 1;//G̐
        for (int vx = -1; vx < 2; vx++) {
            for (int vy = -1; vy < 2; vy++) {
                if (vx == 0 && vy == 0) continue;
                if (x + vx < 0 || x + vx > 7 || y + vy < 0 || y + vy > 7) continue;
                if (b[x + vx, y + vy] != es) continue;
                //̕ɓG̐΂̂ŁAƂ́ẢɎ̐΂΂B
                int x2 = x + vx * 2, y2 = y + vy * 2;
                while (true) {
                    if (x2 < 0 || x2 > 7 || y2 < 0 || y2 > 7) break;//݂͂Ă͂Ȃ
                    if (b[x2, y2] == 0) break;//󔒂Ă͂Ȃ
                    if (b[x2, y2] == s) {
                        //łӏB
                        int x3 = x + vx, y3 = y + vy;
                        while (x3 != x2 || y3 != y2) {
                            b[x3, y3] = s;
                            x3 += vx; y3 += vy;
                        }
                        break;
                    }
                    x2 += vx; y2 += vy;
                }

            }
        }
        return;
    }
    public void PutStone(int x, int y, int s) {
        PutStoneBoard(x, y, s, board);
        count++;
    }
    public void ComputerTurn(out int sx,out int sy,int stone) {
        Think(out sx, out sy, stone,board,(count>50)?1:0);
        return;
    }
    public static void Think(out int sx,out int sy,int st,int [,] b,int mode) {
        //Vvȏc^
        int score = -9999, xx = -1, yy = -1;//ō_Ƃ̈ʒu
        int[,] brd=(int[,])b.Clone();
        for (int y = 0; y < 8; y++) {
            for (int x = 0; x < 8; x++) {
                if (CheckStoneBoard(x, y, st, brd)==true) {
                    //ɂꍇ
                    int sc;
                    if (mode == 0) {
                        sc = CalcScore(x, y, st, brd, 0, 5, score);
                    } else {
                        sc = CalcScore(x, y, st, brd, 1, 10, score);
                    }
                    if (sc > score) {
                        xx = x; yy = y; score = sc;                        
                    }
                }
            }
        }
        sx = xx; sy = yy;
        return;
    }
    public static int CalcScore(int x, int y, int st, int[,] b,int mode,int level,int bscore) {
        //u̓_]B
        int[,] cb = (int [,])b.Clone();
        if (x != -1) PutStoneBoard(x, y, st, cb);
        if (level==0) return AnalyzeBoard(cb, st, mode);
        int score = -9999,xx = -1,yy = -1;
        int est = (st == 1) ? 2 : 1;
        for (int y2 = 0; y2 < 8; y2++) {
            for (int x2 = 0; x2 < 8; x2++) {
                if (CheckStoneBoard(x2, y2, est, cb) == true) {
                    //ɂꍇ
                    int sc = CalcScore(x2, y2, est, cb, mode, level-1,score);
                    if (-sc <= bscore) {
                        return -sc;
                        //؂
                    }
                    if (sc > score) {
                        xx = x2; yy = y2; score = sc;
                    }
                }
            }
        }
        if (score == -9999) {
            return -CalcScore(-1, -1, est, cb,mode,level-1,score);
        }
        return -score;
    }
    public static int AnalyzeBoard(int[,] b, int st,int mode) {
        //Ֆʂ̕]
        int score = 0;
        bool mystoneexist = false,enemystoneexist=false;
        for (int y = 0; y < 8; y++) {
            for (int x = 0; x < 8; x++) {
                if (b[x, y] == 0) continue;
                if (b[x, y] == st) {
                    mystoneexist = true;
                    score += p[x, y, mode];
                } else {
                    enemystoneexist = true;
                    score -= p[x, y, mode];
                }
            }
        }
        if (!mystoneexist) return -5000;//p[tFNgĂ̂
        if (!enemystoneexist) return 5000;//p[tFNgĂ̂
        return score;
    }
}
